2 ##############################################################################
3 # Copyright (c) 2015 Ericsson AB and others.
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
12 # Set up the environment and run yardstick test suites.
14 # Example invocation: yardstick-verify -r 10.4.4.4 suite1.yaml suite2.yaml
16 # Openstack credentials must be set and the script must be run from its
17 # original location in the yardstick repo.
19 # This script is intended to be used by the CI pipeline but it may also
20 # be invoked manually.
29 usage: $0 options [TEST_SUITE ...]
31 If no test suites are given ping.yaml is run.
35 -r Http target (example: -r 213.77.62.197/results)
36 -i Influxdb target (example: -i 127.0.0.1:8086)
38 Default target is dump to file ($DISPATCHER_FILE_NAME)
44 DISPATCHER_FILE_NAME="/tmp/yardstick.out"
45 DISPATCHER_HTTP_TARGET="http://testresults.opnfv.org/test/api/v1/results"
46 DISPATCHER_INFLUXDB_TARGET=
48 while getopts "r:i:h" OPTION; do
56 DISPATCHER_HTTP_TARGET=http://${OPTARG}
60 DISPATCHER_TYPE=influxdb
61 DISPATCHER_INFLUXDB_TARGET=http://${OPTARG}
65 echo "${OPTION} is not a valid argument"
77 echo "========== Cleanup =========="
79 if ! glance image-list; then
83 for image in $(glance image-list | grep -e cirros-0.3.3 -e yardstick-trusty-server -e Ubuntu-14.04 | awk '{print $2}'); do
84 echo "Deleting image $image..."
85 glance image-delete $image || true
88 nova flavor-delete yardstick-flavor &> /dev/null || true
97 if [ -z "$exitcode" ]; then
98 # In case of recursive traps (!?)
104 echo "Exiting with RC=$exitcode"
115 echo "========== Installing yardstick =========="
117 # uninstall previous version
118 pip uninstall -y yardstick || true
126 # Install Storper on huawei-pod1
127 if [ "$NODE_NAME" == "huawei-pod1" ]; then
129 echo "========== Installing storperf =========="
131 if ! yardstick -d plugin install plugin/CI/storperf.yaml; then
132 echo "Install storperf plugin FAILED";
137 echo "========== Installed storperf container =========="
141 build_yardstick_image()
144 echo "========== Build yardstick cloud image =========="
146 local cmd="sudo $(which yardstick-img-modify) $(pwd)/tools/ubuntu-server-cloudimg-modify.sh"
148 # Build the image. Retry once if the build fails.
151 if [ ! -f $QCOW_IMAGE ]; then
152 echo "Failed building QCOW image"
159 if ! nova flavor-list | grep -q yardstick-flavor; then
161 echo "========== Create nova flavor =========="
162 # Create the nova flavor used by some sample test cases
163 nova flavor-create yardstick-flavor 100 512 3 1
164 # DPDK-enabled OVS requires guest memory to be backed by large pages
165 if [[ "$DEPLOY_SCENARIO" == *"-ovs-"* ]]; then
166 nova flavor-key yardstick-flavor set hw:mem_page_size=large
174 echo "========== Loading cirros cloud image =========="
176 local image_file=/home/opnfv/images/cirros-0.3.3-x86_64-disk.img
178 output=$(glance image-create \
179 --name cirros-0.3.3 \
180 --disk-format qcow2 \
181 --container-format bare \
185 CIRROS_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
186 if [ -z "$CIRROS_IMAGE_ID" ]; then
187 echo 'Failed uploading cirros image to cloud'.
191 echo "Cirros image id: $CIRROS_IMAGE_ID"
197 echo "========== Loading ubuntu cloud image =========="
199 local ubuntu_image_file=/home/opnfv/images/trusty-server-cloudimg-amd64-disk1.img
201 output=$(glance image-create \
202 --name Ubuntu-14.04 \
203 --disk-format qcow2 \
204 --container-format bare \
205 --file $ubuntu_image_file)
208 UBUNTU_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
210 if [ -z "$UBUNTU_IMAGE_ID" ]; then
211 echo 'Failed uploading UBUNTU image to cloud'.
215 echo "Ubuntu image id: $UBUNTU_IMAGE_ID"
218 load_yardstick_image()
221 echo "========== Loading yardstick cloud image =========="
223 output=$(glance --os-image-api-version 1 image-create \
224 --name yardstick-trusty-server \
225 --is-public true --disk-format qcow2 \
226 --container-format bare \
230 GLANCE_IMAGE_ID=$(echo "$output" | grep " id " | awk '{print $(NF-1)}')
232 if [ -z "$GLANCE_IMAGE_ID" ]; then
233 echo 'Failed uploading image to cloud'.
237 sudo rm -f $QCOW_IMAGE
239 echo "Glance image id: $GLANCE_IMAGE_ID"
245 echo "========== Running yardstick test suites =========="
247 mkdir -p /etc/yardstick
249 cat << EOF >> /etc/yardstick/yardstick.conf
252 dispatcher = ${DISPATCHER_TYPE}
255 file_name = ${DISPATCHER_FILE_NAME}
259 target = ${DISPATCHER_HTTP_TARGET}
261 [dispatcher_influxdb]
263 target = ${DISPATCHER_INFLUXDB_TARGET}
271 if [ ${#SUITE_FILES[@]} -gt 0 ]; then
273 for suite in ${SUITE_FILES[*]}; do
275 echo "---------------------------"
276 echo "Running test suite: $suite"
277 echo "---------------------------"
279 if ! yardstick task start --suite $suite; then
280 echo "test suite $suite FAILED";
282 # Mark the test suite failed but continue
283 # running the remaining test suites.
286 if [ ${DISPATCHER_TYPE} = file ]; then
287 echo "---------------------------"
288 echo "Dump test suite $suite result"
289 echo "---------------------------"
290 if [ -f ${DISPATCHER_FILE_NAME} ]; then
291 cat ${DISPATCHER_FILE_NAME}
293 echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
299 local sceanrio_status="SUCCESS"
301 if [ $failed -gt 0 ]; then
302 scenario_status="FAILED"
304 curl -i -H 'content-type: application/json' -X POST -d \
305 "{\"project_name\": \"yardstick\",
306 \"pod_name\":\"${NODE_NAME}\",
307 \"installer\":\"${INSTALLER_TYPE}\",
308 \"description\": \"yardstick ci scenario status\",
309 \"case_name\": \"scenario_status\",
310 \"version\":\"${YARDSTICK_BRANCH}\",
311 \"scenario\":\"${DEPLOY_SCENARIO}\",
312 \"details\":\"${sceanrio_status}\"}" \
313 ${DISPATCHER_HTTP_TARGET}
315 if [ $failed -gt 0 ]; then
316 echo "---------------------------"
317 echo "$failed out of ${SUITE_FILES[*]} test suites FAILED"
318 echo "---------------------------"
324 echo "---------------------------"
325 echo "Running samples/ping.yaml "
326 echo "---------------------------"
328 if ! yardstick task start samples/ping.yaml; then
329 echo "Yardstick test FAILED"
333 if [ ${DISPATCHER_TYPE} = file ]; then
334 echo "---------------------------"
335 echo "Dump samples/ping.yaml test result"
336 echo "---------------------------"
337 if [ -f ${DISPATCHER_FILE_NAME} ]; then
338 cat ${DISPATCHER_FILE_NAME}
340 echo "Test result file ${DISPATCHER_FILE_NAME} is not exist"
350 GITROOT=$(cd $(dirname $0) && git rev-parse --show-toplevel)
354 export YARDSTICK_VERSION=$(git rev-parse HEAD)
358 # find the test suite files
359 for suite in $TEST_SUITES; do
360 if [ -f $suite ]; then
361 SUITE_FILES+=($suite)
363 tsdir=$GITROOT/tests/opnfv/test_suites
364 if [ ! -f $tsdir/$suite ]; then
365 echo "Test suite \"$suite\" does not exist"
368 SUITE_FILES+=($tsdir/$suite)
373 echo "========== Running Yardstick CI with following parameters =========="
374 echo "Script options: ${SCRIPT} $SCRIPT_ARGS"
375 echo "Dispatcher: ${DISPATCHER_TYPE} ${DISPATCHER_FILE_NAME}"
376 echo "YARDSTICK_VERSION: ${YARDSTICK_VERSION}"
377 echo "Number of test suites: ${#SUITE_FILES[@]}"
378 for suite in ${SUITE_FILES[*]}; do
383 # check if some necessary variables is set
384 if [ -z "$OS_AUTH_URL" ]; then
385 echo "OS_AUTH_URL is unset or empty"
389 echo "OS_AUTH_URL is $OS_AUTH_URL"
392 # check OpenStack services
393 echo "Checking OpenStack services:"
394 for cmd in "glance image-list" "nova list" "heat stack-list"; do
395 echo " checking ${cmd/%\ */} ..."
396 if ! $cmd >/dev/null; then
397 echo "error: command \"$cmd\" failed"
403 echo "Checking for External network:"
404 for net in $(neutron net-list --router:external True -c name -f value); do
405 echo " external network: $net"
413 trap "error_exit" EXIT SIGTERM
415 QCOW_IMAGE="/tmp/workspace/yardstick/yardstick-trusty-server.img"
417 build_yardstick_image